#include "vfd_digits.hpp"
#include "shift_register.hpp"

constexpr int DATA_PIN = D2;
constexpr int OE_PIN = D3;
constexpr int RCLK_PIN = D7;
constexpr int SCLK_PIN = D8;

ShiftRegister sr;
uint32_t last_digit_time;
constexpr uint32_t PERIOD_MS = 1000;
uint8_t digit = 0;
uint8_t last_digit = 0;

uint8_t ordered_pins[8] = { 0b10100000, 0b10010000, 0b10001000, 0b10000100, 0b01100000, 0b01010000, 0b01001000, 0b01000100 };
uint8_t pin_index = 0;
void setup() {
  // put your setup code here, to run once:
  sr.init(DATA_PIN, SCLK_PIN, RCLK_PIN, OE_PIN);
  last_digit_time = millis();
}


void loop() {
  if (millis() - last_digit_time > PERIOD_MS) {
    digit = (digit + 1) % 10;
    last_digit_time = millis();
  }
  switch (digit) {
    case 0:
      while (pin_index != 8){
        sr.shift_data(ordered_pins[pin_index]);
        pin_index++;
        delay(50);
      }
      pin_index = 0;
    case 1:
      sr.shift_data(VFD_DIGIT_0);
      break;
    case 2:
      sr.shift_data((VFD_DIGIT_6));
      break;
    case 3:
      sr.shift_data((VFD_DIGIT_8));
      break;
    case 4:
      sr.shift_data((VFD_DIGIT_9));
      break;
    case 5:
      sr.shift_data(VFD_DIGIT_A);
      break;
    case 6:
      sr.shift_data(VFD_DIGIT_B);
      break;
    case 7:
      sr.shift_data(VFD_DIGIT_E);
      break;
    case 8:
      sr.shift_data(VFD_DIGIT_F);
      break;
    case 9:
      sr.shift_data(VFD_DIGIT_H);
      break;
    case 10:
      sr.shift_data(VFD_DIGIT_P);
      break;
  }
}
