#pragma once
#include <stdint.h>

class ShiftRegister {
  public:
    ShiftRegister(){};
    // Shift 8 bits of data into the register and update its output
    void shift_data(uint8_t data);
    // Enable the shift register and clear it
    void init(int dataPin, int sClkPin, int rClkPin, int oePin);
  private:
    int dataPin;
    int sClkPin;
    int rClkPin;
    int oePin;

    // Shift one bit into the register
    inline void shift_in_bit(bool bit);
    inline void pulse_shift_clock();
    inline void pulse_register_clock();
};
