#pragma once

// Reference Schematic and Datasheet (https://www.tube-tester.com/sites/nixie/dat_arch/IV-22.pdf)
// For some digits our matrix layout cannot display directly, so we must split it into two differnt bytes and flash between the two. We store the two bytes into a uint16_t. For digits that can be displayed with one byte we store it in just uint8_t. 

constexpr uint8_t VFD_DIGIT_0 = 0b01001000;

constexpr uint16_t VFD_DIGIT_6 = 0b10010000;

constexpr uint16_t VFD_DIGIT_8 = 0;

constexpr uint16_t VFD_DIGIT_9 = 0b01100000;

constexpr uint8_t VFD_DIGIT_A = 0b10000100;

constexpr uint8_t VFD_DIGIT_B = 0b10110000;

constexpr uint8_t VFD_DIGIT_E = 0b10011000;

constexpr uint8_t VFD_DIGIT_F = 0b10011100;

constexpr uint8_t VFD_DIGIT_H = 0b10100100;

constexpr uint8_t VFD_DIGIT_P = 0b10001100;
